#------------------------------------------------------------------------
# -*- mode: cmake -*-
#
#------------------------------------------------------------------------
function( ax_pkg_check_modules var )
  #----------------------------------------------------------------------
  # Handle argument parsing
  #----------------------------------------------------------------------
  set( options
  )
  set( oneValueArgs
  )
  set( multiValueArgs
  )
  cmake_parse_arguments(ARG "${options}" "${oneValueArgs}" "${multiValueArgs}" ${ARGN} )
  #----------------------------------------------------------------------
  #----------------------------------------------------------------------
  pkg_check_modules( ${var} ${ARG_UNPARSED_ARGUMENTS} )
  message( STATUS "${var}_STATIC_LIBRARIES: ${${var}_STATIC_LIBRARIES}" )
  set( new_libs )
  foreach( LIB ${${var}_STATIC_LIBRARIES} )
    unset( found )
    foreach( DIR ${${var}_LIBRARY_DIRS} )
      set( libname "${DIR}/${CMAKE_STATIC_LIBRARY_PREFIX}${LIB}${CMAKE_STATIC_LIBRARY_SUFFIX}" )
      if ( EXISTS "${libname}" )
        list( APPEND new_libs "${libname}" )
	set( found TRUE )
	break( )
      endif ( EXISTS "${libname}" )
    endforeach( DIR ${${var}_LIBRARY_DIRS} )
    if ( NOT found )
      list( APPEND new_libs "${LIB}" )
    endif( NOT found )
  endforeach( LIB ${${var}_LIBRARIES} )
  set( ${var}_STATIC_LIBRARIES ${new_libs} CACHE INTERNAL "" )
  message( STATUS "new_libs: ${new_libs}" )

endfunction( ax_pkg_check_modules )
